#!/bin/bash

# Commands to produce data comparing the speed of the installed
# version of R without byte compilation and with byte compilation on
# the simple test programs, and then produce a plot of the results, 
# in example.pdf.

set -e

export version=`R RHOME`

export R_ENABLE_JIT=0         # use explict compilation only, not JIT

export R_USE_BYTECODE=TRUE    # needed to enable bytecode in recent pqR versions
export R_PKG_BYTECOMPILE=TRUE

rm -f test-times

rep=2 cmp=F do-prg            # tests without bytecode compilation
rep=2 cmp=T do-prg            # tests with bytecode compilation

R CMD BATCH example.r
