source("time.r")
 
# COMPUTE GREATEST COMMON DIVISOR.

gcd1 <- test.cmp(function (a,b) 
  if (a > b) gcd1(a-b,b) else if (b > a) gcd1(a,b-a) else a)

gcd2 <- test.cmp(function (a,b) 
{ if (a == 0) b 
  else if (b == 0) a 
  else if (a > b) gcd2(a%%b,b) 
  else gcd2(a,b%%a) 
})

gcd3 <- test.cmp(function (a,b) 
{ repeat
  { if (a > b) { a <- a-b; next }
    if (b > a) { b <- b-a; next }
    return (a);
  }
})

gcd4 <- test.cmp(function (a,b) 
{ repeat
  { if (a == 0) return (b)
    if (b == 0) return (a)
    if (a > b) a <- a%%b
    else b <- b%%a
  }
})

gcd5 <- test.cmp(function (a,b) 
{ while (a != b)
  { if (a > b) a <- a-b
    else b <- b-a
  }
  a
})

gcd_table <- test.cmp(function (n,gcd)
{
  tbl <- matrix(integer(),n,n)
  for (i in 1:n)
    for (j in 1:n)
      tbl[i,j] <- gcd(i,j)
  tbl
})


test.name <- "prg-gcd"

sys.time(r1 <- gcd_table(500,gcd1))
print(r1[1:11,1:11])

sys.time(r2 <- gcd_table(500,gcd2))
print(r2[1:11,1:11])

sys.time(r3 <- gcd_table(500,gcd3))
print(r3[1:11,1:11])

sys.time(r4 <- gcd_table(500,gcd4))
print(r4[1:11,1:11])

sys.time(r5 <- gcd_table(500,gcd5))
print(r5[1:11,1:11])

print(identical(r1,r2))
print(identical(r1,r3))
print(identical(r1,r4))
print(identical(r1,r5))
