source("time.r")
 
# PRIME COUNTING FUNCTION.  This is an R implementation of an algorithm
# that was used as a speed test for many languages in the blog post at
# https://bjpelc.wordpress.com/2015/01/10/yet-another-language-speed-test-counting-primes-c-c-java-javascript-php-python-and-ruby-2/
# It seems to have disappeared from there, but a cached version is at 
# https://hackerfall.com/story/yet-another-language-speed-test--counting-primes

isPrime <- test.cmp(function (n)
{ if (n < 2) FALSE
  else if (n == 2) TRUE
  else if (n %% 2 == 0) FALSE
  else
  { upperLimit <- sqrt(n);
    i <- 3
    while (i <= upperLimit)
    { if (n %% i == 0) return(FALSE)
      i <- i + 2
    }
    TRUE
  }
})

doit <- test.cmp(function (LIMIT)
{ limit <- 2^LIMIT
  noPrimes <- 0
  for (n in 0:limit)
  { if (isPrime(n)) noPrimes <- noPrimes + 1
  }
  paste("pi(",limit,") = ",noPrimes,"\n",sep="")
})

test.name <- "prg-primes"

sys.time(r <- doit(16))
cat(r)

sys.time(r <- doit(18))
cat(r)
