source("time.r")

# SIEVE OF ERATOSTHENES.

sieve1 <- test.cmp(function (n) 
{
  composite <- logical(n)
  composite[1] <- TRUE

  for (i in 2:n) 
  { if (!composite[i])
    { j <- 2*i
      while (j <= n) { composite[j] <- TRUE; j <- j + i }
    }
  }

  (1:n)[!composite]
})

test.name <- "prg-sieve.1"

sys.time(for (i in 1:2000) ra1 <- sieve1(1000))
print(ra1)

sys.time(for (i in 1:2) rb1 <- sieve1(1000000))
print(rb1[c(1:10,(length(rb1)-9):length(rb1))])


sieve2 <- test.cmp(function (n) 
{
  composite <- logical(n)
  composite[1] <- TRUE

  for (i in 2:(n/2)) 
  { if (!composite[i])
    { composite [seq.int (from=2*i, to=n, by=i)] <- TRUE
    }
  }

  (1:n)[!composite]
})

test.name <- "prg-sieve.2"

sys.time(for (i in 1:10000) ra2 <- sieve2(1000))
print(ra2)

sys.time(for (i in 1:10) rb2 <- sieve2(1000000))
print(rb2[c(1:10,(length(rb2)-9):length(rb2))])

print(identical(ra1,ra2))
print(identical(rb1,rb2))
