source("time.r")

# Examples of character-level text manipulation. 


test.name <- "prg-text.look"

# Count number of matches between corresponding characters in pairs of
# strings.

count <- test.cmp(function (s1, s2) 
{
    cnt <- 0
    for (i in seq_len(min(nchar(s1),nchar(s2))))
        if (substr(s1,i,i) == substr(s2,i,i)) 
            cnt <- cnt + 1
    cnt
})

a <- "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
b <- "ABCDEFG.IJKLMNOPQ.STUVWXYZ"
c <- "........IJ........S....................................................."

sys.time (for (i in 1:50000) r <- count(a,b))
print(r)

sys.time (for (i in 1:50000) r <- count(a,c))
print(r)


test.name <- "prg-text.replace"

# Replace all occurrences of character c in strings in vector s with 
# successive characters from v, recycling as necessary.

replace <- test.cmp(function (s, c, v) 
{
    k <- 1
    for (i in seq_along(s)) {
        for (j in 1:nchar(s[i])) {
            if (substr(s[i],j,j) == c) {
                substr(s[i],j,j) <- substr(v,k,k)
                k <- k+1
                if (k > nchar(v)) k <- 1;
            }
        }
    }

    s
})

s1 <- rep(c("abc.defg.hijklm","x.y.z",".","pqrstuvwxyz"),1000)
sys.time(for (i in 1:30) r <- replace(s1,".","ABCDEFG"))
print(r[1:20])

s2 <- paste("x",1:100000,"y")
sys.time(r <- replace(s2,"4","ABCDEFGHIJK"))
print(r[1:50])

s3 <- rep(c("a...b","..c..","....","x.y"),1000)
sys.time(for (i in 1:30) r <- replace(s3,".","ABCDEFGHIJKLMNOPQRSTUVWXYZ"))
print(r[1:20])
