source("time.r")

f1 <- test.cmp (function (x) sum(x)+10000)
f2 <- test.cmp (function (x,a) sum(x)+a)
f3 <- test.cmp (function (x) c(sum(x),-1))

S <- list()
for (i in 1:9) S[[i]] <- rep(1.01*i,100)

F <- new.env()
for (i in 1:length(S)) F[[paste("v",i,sep="")]] <- S[[i]]

L <- list()
for (i in 1:99) L[[i]] <- rep(1.01*i,100)

E <- new.env()
for (i in 1:length(L)) E[[paste("v",i,sep="")]] <- L[[i]]


test.name <- "tst-apply.lapply"

f <- test.cmp(function()
  { for (i in 1:100000) a <- wait(lapply(S,f1)); a })
sys.time(a<-f())
print(unlist(a))

f <- test.cmp(function()
  { for (i in 1:100000) a <- wait(lapply(S,f2,10000)); a })
sys.time(a<-f())
print(unlist(a))

f <- test.cmp(function()
  { for (i in 1:100000) a <- wait(lapply(S,f3)); a })
sys.time(a<-f())
print(unlist(a))

f <- test.cmp(function()
  { for (i in 1:10000) a <- wait(lapply(L,f1)); a })
sys.time(a<-f())
print(unlist(a))

f <- test.cmp(function()
  { for (i in 1:10000) a <- wait(lapply(L,f2,10000)); a })
sys.time(a<-f())
print(unlist(a))

f <- test.cmp(function()
  { for (i in 1:10000) a <- wait(lapply(L,f3)); a })
sys.time(a<-f())
print(unlist(a))


test.name <- "tst-apply.vapply"

f <- test.cmp(function()
  { for (i in 1:100000) a <- wait(vapply(S,f1,numeric(1))); a })
sys.time(a<-f())
print(unlist(a))

f <- test.cmp(function()
  { for (i in 1:100000) a <- wait(vapply(S,f2,numeric(1),10000)); a })
sys.time(a<-f())
print(unlist(a))

f <- test.cmp(function()
  { for (i in 1:100000) a <- wait(vapply(S,f3,numeric(2))); a })
sys.time(a<-f())
print(unlist(a))

f <- test.cmp(function()
  { for (i in 1:10000) a <- wait(vapply(L,f1,numeric(1))); a })
sys.time(a<-f())
print(unlist(a))

f <- test.cmp(function()
  { for (i in 1:10000) a <- wait(vapply(L,f2,numeric(1),10000)); a })
sys.time(a<-f())
print(unlist(a))

f <- test.cmp(function()
  { for (i in 1:10000) a <- wait(vapply(L,f3,numeric(2))); a })
sys.time(a<-f())
print(unlist(a))


test.name <- "tst-apply.eapply"

f <- test.cmp(function()
  { for (i in 1:100000) a <- wait(eapply(F,f1)); a[order(names(a))] })
sys.time(a<-f())
print(unlist(a))

f <- test.cmp(function()
  { for (i in 1:100000) a <- wait(eapply(F,f2,10000)); a[order(names(a))] })
sys.time(a<-f())
print(unlist(a))

f <- test.cmp(function()
  { for (i in 1:100000) a <- wait(eapply(F,f3)); a[order(names(a))] })
sys.time(a<-f())
print(unlist(a))

f <- test.cmp(function()
  { for (i in 1:10000) a <- wait(eapply(E,f1)); a[order(names(a))] })
sys.time(a<-f())
print(unlist(a))

f <- test.cmp(function()
  { for (i in 1:10000) a <- wait(eapply(E,f2,10000)); a[order(names(a))] })
sys.time(a<-f())
print(unlist(a))

f <- test.cmp(function()
  { for (i in 1:10000) a <- wait(eapply(E,f3)); a[order(names(a))] })
sys.time(a<-f())
print(unlist(a))
