source("time.r")
 

test.name <- "tst-class.S3"

a <- 5; class(a) <- "fred"
b <- 7; class(b) <- "mary"

addzero <- test.cmp (function (x) UseMethod("addzero"))

addzero.fred <- test.cmp (function (x) c(x,0))
addzero.mary <- test.cmp (function (x) c(0,x))
addzero.default <- test.cmp (function (x) c(8,9))

addzeroc <- test.cmp (function (x) UseMethod("addzeroc"))

addzeroc.fred <- test.cmp (function (x) { r <- c(x,0); class(r) <- "fred"; r })
addzeroc.mary <- test.cmp (function (x) { r <- c(0,x); class(r) <- "mary"; r })

f <- test.cmp (function (n,a,b) 
{ for (i in 1:n) r <- list(addzero(a),addzero(b))
  r
})

sys.time(r <- f(300000,a,b))
print(r)

sys.time(r <- f(300000,2,TRUE))
print(r)

g <- test.cmp (function (n,a,b) 
{ for (i in 1:n) r <- list(addzeroc(a),addzeroc(b))
  r
})

sys.time(r <- g(300000,a,b))
print(r)

seq.fred <- test.cmp (function (x,y) c(x,0,y))

f <- test.cmp (function (n,x,y) 
{ for (i in 1:n) r <- seq(x,y)
  r
})

sys.time(r <- f(500000,a,9))
print(r)

f <- test.cmp (function (n, x)
{ for (i in 1:n) r <- x+1
  r
})

sys.time(r <- f(1000000,a))
print(r)

f <- test.cmp (function (n, x)
{ for (i in 1:n) r <- x$q
  r
})

s <- list(q=101)
class(s) <- "bert"
sys.time(r <- f(1000000,s))
print(r)


test.name <- "tst-class.unclass"

`+.mod12` <- test.cmp (function (x,y) 
{ s <- (unclass(x) + unclass(y)) %% 12L
  class(s) <- "mod12"
  s
})

f <- test.cmp (function (n,a,b) 
{ for (i in 1:n) r <- wait(a+b)
  r
})

a <- 6L; class(a) <- "mod12"
b <- 8L; class(b) <- "mod12"

sys.time(r <- f(500000,a,b))
print(r)

a <- rep(6L,200); class(a) <- "mod12"
b <- rep(8L,200); class(b) <- "mod12"

sys.time(r <- f(500000,a,b))
print(r)

a <- rep(6L,100000); class(a) <- "mod12"
b <- rep(8L,100000); class(b) <- "mod12"

sys.time(r <- f(5000,a,b))
print(sum(r))

`[.mod12` <- test.cmp (function (x,i) unclass(x)[i] %% 12L )

g <- test.cmp (function (n,a,i)
{ for (i in 1:n) r <- wait(a[i])
  r
})

sys.time(r <- g(100000,a,3000))
print(r)


test.name <- "tst-class.S4"


imsqrt <- test.cmp (function (x) standardGeneric("imsqrt"))
fiddle <- test.cmp (function (x) standardGeneric("fiddle"))
fiddle2 <- test.cmp (function (x) standardGeneric("fiddle2"))

setClass ("bert",representation(x="integer",a="complex"),
                 prototype(x=c(30L,1:999),a=0+0i))
setClass ("gwen",representation(x="integer",a="complex"),
                 prototype(x=c(30L,40L),a=0+0i))

setMethod ("sqrt", "bert", test.cmp (function(x) sqrt(Re(x@a))))
setMethod ("imsqrt", "bert", test.cmp (function(x) sqrt(Im(x@a))))
setMethod ("imsqrt", "gwen", test.cmp (function(x) sqrt(Re(x@a)+Im(x@a))))
setMethod ("fiddle", "bert", test.cmp (function(x) new("gwen",a=x@a+1)))
setMethod ("fiddle", "gwen", test.cmp (function(x) new("bert",a=x@a-1i)))
setMethod ("fiddle2", "bert", 
          test.cmp (function(x) { for (i in 1:100) x@a <- x@a-7; x@a }))
setMethod ("fiddle2", "gwen", 
          test.cmp (function(x) { for (i in 1:100) x@x[2] <- x@x[2]+7L; x@x }))

z <- new("bert")
z@a <- 2+5i

w <- new("gwen")
w@a <- 2+5i

f <- test.cmp (function (n,z) 
{ for (i in 1:n) r <- sqrt(z); 
  r 
})

sys.time(r <- f(2000000,z))
print(r)

f <- test.cmp (function (n,w,z) 
{ for (i in 1:n) r <- 100*imsqrt(w) + imsqrt(z); 
  r 
})

sys.time(r <- f(100000,w,z))
print(r)

f <- test.cmp (function (n,q) { for (i in 1:n) q <- fiddle(q); q })

sys.time(r <- f(10000,z))
print(r)

sys.time(r <- f(10000,w))
print(r)

f <- test.cmp (function (n,x) { for (i in 1:n) r <- fiddle2(x); r })

sys.time(r <- f(3000,z))
print(r)

sys.time(r <- f(1000,w))
print(sum(r))
