source("time.r")

test.name <- "tst-io.write.table"

m <- 1000

df <- data.frame (x=rep(c(TRUE,FALSE,NA,FALSE,TRUE),m),
                  y=rep(c(-2,3.1,1.1e8,0,NA),m),
                  z=rep(c(NA,4L,-9L,0L,1234L),m))

f <- test.cmp (function (n,d,f)
{ for (i in 1:n) write.table(d,f,quote=FALSE,row.names=FALSE,col.names=FALSE)
})

sys.time (f(100,df,"tst-io-file-r"))

M <- matrix(c(3.1,4.1,-8.2),3000,20)

sys.time (f(10,M,"tst-io-file-s"))

test.name <- "tst-io.writeLines"

textp <- rep("1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20",10000)
textq <- rep ("1.23 -2",10000)

g <- test.cmp (function (n,w,f)
{ for (i in 1:n) writeLines(w,f)
})

sys.time (g (200, textp, "tst-io-file-p"))

sys.time (g (300, textq, "tst-io-file-q"))

test.name <- "tst-io.readLines"

f <- test.cmp (function (n,f) 
{ for (i in 1:n) a <- wait(readLines(f))
  a 
})

sys.time(r <- f(100,"tst-io-file-p"))

cat(r[1],"\n",r[10000],"\n",sep="")
stopifnot(identical(r,textp))

sys.time(r <- f(1000,"tst-io-file-q"))

cat(r[1],"\n",r[10000],"\n",sep="")
stopifnot(identical(r,textq))

test.name <- "tst-io.scan"

f <- test.cmp (function (n,f,t) 
{ for (i in 1:n) a <- wait(scan(f,t,quiet=TRUE))
  a 
})

sys.time(r <- f(50,"tst-io-file-p",integer()))

print(length(r))
print(sum(r))

sys.time(r <- f(300,"tst-io-file-q",numeric()))

print(length(r))
print(sum(r))
