source("time.r")

test.name <- "tst-regexp.grepl"

f <- test.cmp (function (p,q,n) 
{ for (i in 1:n) r <- grepl(p,q)
  r
})

sys.time(r <- f("xy","abxyc",500000))
sys.time(r <- f("xy","abpqc",500000))

test.name <- "tst-regexp.grep"

f <- test.cmp (function (p,q,n) 
{ for (i in 1:n) r <- grep(p,q)
  r
})

x <- c("x","ab","xaby","asss","xaqqby","xxxxxaxxxxxbxxxxaxxxxxxxxxxxxxxxxxxxab")
xx <- rep(x,100)
xxx <- paste(xx,collapse="-")

sys.time(r <- f("PQ",x,500000))
print(r)
sys.time(r <- f("PQ",xx,30000))
sys.time(r <- f("PQ",xxx,300000))

sys.time(r <- f("ab",x,500000))
print(r)
sys.time(r <- f("ab",xx,30000))
sys.time(r <- f("ab",xxx,300000))

sys.time(r <- f("a.*b",x,500000))
print(r)
sys.time(r <- f("a.*b",xx,30000))
sys.time(r <- f("a.*b",xxx,300000))

f <- test.cmp (function (p,q,n) 
{ for (i in 1:n) r <- grep(p,q,fixed=TRUE)
  r
})

sys.time(r <- f("PQ",x,1000000))
print(r)
sys.time(r <- f("ab",x,1000000))
print(r)

f <- test.cmp (function (p,q,n) 
{ for (i in 1:n) r <- grep(p,q,perl=TRUE)
  r
})

sys.time(r <- f("a.*b",x,200000))
print(r)
sys.time(r <- f("a.*b",xx,30000))
sys.time(r <- f("a.*b",xxx,100000))

test.name <- "tst-regexp.sub"

g <- test.cmp (function (p,q,n) 
{ for (i in 1:n) r <- sub(p,"QQQ",q)
  r
})

x <- c("x","ab","xaby","asss","xaqqby")
xx <- rep(x,100)
xxx <- paste(xx,collapse="-")

sys.time(r <- g("PQ",x,500000))
print(r)
sys.time(r <- g("PQ",xx,10000))

sys.time(r <- g("ab",x,500000))
print(r)
sys.time(r <- g("ab",xx,10000))

sys.time(r <- g("a.*b",x,500000))
print(r)
sys.time(r <- g("a.*b",xx,10000))

g <- test.cmp (function (p,q,n) 
{ for (i in 1:n) r <- sub(p,"QQQ",q,fixed=TRUE)
  r
})

sys.time(r <- g("ab",x,1000000))
print(r)

g <- test.cmp (function (p,q,n) 
{ for (i in 1:n) r <- sub(p,"QQQ",q,perl=TRUE)
  r
})

sys.time(r <- g("a.*b",x,300000))
print(r)
sys.time(r <- g("a.*b",xx,30000))

test.name <- "tst-regexp.gsub"

g <- test.cmp (function (p,q,n) 
{ for (i in 1:n) r <- gsub(p,"QQQ",q)
  r
})

x <- c("x","ab","xaby","asss","xaqqby")
xx <- rep(x,100)
xxx <- paste(xx,collapse="-")

sys.time(r <- g("PQ",xxx,300000))
sys.time(r <- g("ab",xxx,30000))
sys.time(r <- g("a.*b",xxx,30000))

g <- test.cmp (function (p,q,n) 
{ for (i in 1:n) r <- gsub(p,"QQQ",q,fixed=TRUE)
  r
})

sys.time(r <- g("ab",xxx,30000))

g <- test.cmp (function (p,q,n) 
{ for (i in 1:n) r <- gsub(p,"QQQ",q,perl=TRUE)
  r
})

sys.time(r <- g("PQ",xxx,100000))
sys.time(r <- g("ab",xxx,30000))
sys.time(r <- g("a.*b",xxx,100000))
