source("time.r")

fs <- test.cmp (function (x,n) { for (i in 1:n) r <- sort(x); r })
fo <- test.cmp (function (x,n) { for (i in 1:n) r <- order(x); r })
fr <- test.cmp (function (x,n) { for (i in 1:n) r <- rank(x); r })

test.name <- "tst-sort.small-char"
a <- c("a","x","y","a","x","b")

sys.time(r <- fs(a,300000))
print(r)

sys.time(r <- fo(a,300000))
print(r)
 

test.name <- "tst-sort.integer"

set.seed(1)

a <- 100:100000
b <- sample(a)

sys.time(r <- fs(b,500))
print(length(r))
print(all(r==a))

sys.time(r <- fo(b,500))
print(length(r))
print(all(b[r]==a))


test.name <- "tst-sort.real"

set.seed(1)

a <- (100:100000) + 0.1
b <- sample(a)

sys.time(r <- fs(b,500))
print(length(r))
print(all(r==a))

sys.time(r <- fo(b,500))
print(length(r))
print(all(b[r]==a))


test.name <- "tst-sort.character"

set.seed(1)

a <- paste("x",100:100000,sep="")
b <- sample(a)

sys.time(r <- fs(b,100))
print(length(r))
print(all(r==a))

sys.time(r <- fo(b,100))
print(length(r))
print(all(b[r]==a))


test.name <- "tst-sort.rank"

set.seed(1)

b <- sample(1000:9999)

sys.time(r <- fr(b,1000))
print(r[1:10])

b <- b + 0.1
sys.time(r <- fr(b,1000))
print(r[1:10])

b <- as.character(b)
sys.time(r <- fr(b,1000))
print(r[1:10])



