source("time.r")

f <- test.cmp (function (p,q,n) 
{ for (i in 1:n) { r1 <- p < q; r2 <- p == q }
  c(r1,r2)
})

test.name <- "tst-strcmp.ascii"

icuSetCollate(locale="ASCII")

a <- "abcdef"
b <- "abcxyz"

sys.time(r <- f(a,b,10000000))
print(r)

sys.time(r <- f(a,a,10000000))
print(r)

A <- paste(c(rep(a,20),"a"),collapse="")
B <- paste(c(rep(a,20),"b"),collapse="")

sys.time(r <- f(A,B,10000000))
print(r)

sys.time(r <- f(c(a,b),c(b,a),5000000))
print(r)

test.name <- "tst-strcmp.utf-8"

icuSetCollate(locale="root")

x <- "abcde\u00c1"
y <- "abcde\u00c2"

sys.time(r <- f(x,y,10000000))
print(r)

sys.time(r <- f(x,x,10000000))
print(r)

X <- paste(c(rep(x,20),"a"),collapse="")
Y <- paste(c(rep(x,20),"b"),collapse="")

sys.time(r <- f(X,Y,1000000))
print(r)

xl <- iconv(x,from="UTF-8",to="latin1")

sys.time(r <- f(xl,y,1000000))
print(r)
