source("time.r")


# Functions to access or replace the head or the tail of a vector.

hd <- test.cmp (function (x, n=1) x[seq_len(n)])
tl <- test.cmp (function (x, n=1) x[length(x)-n+seq_len(n)])

`hd<-` <- test.cmp (function (x, n=1, value) 
           { x[seq_len(n)] <- value; x })
`tl<-` <- test.cmp (function (x, n=1, value) 
           { x[length(x)-n+seq_len(n)] <- value; x })


test.name <- "tst-subfns.access"

rv <- seq(1,2,length=100001)

rn <- test.cmp (function () 
  { s <- 0; for (i in 1:1000000) s <- s + hd(rv); s })
sys.time(s <- rn())
print(s)

rn <- test.cmp (function () 
  { s <- 0; for (i in 1:1000000) s <- s + hd(rv,5); s })
sys.time(s <- rn())
print(s)

rn <- test.cmp (function () 
  { s <- 0; for (i in 1:1000000) s <- s + tl(rv); s })
sys.time(s <- rn())
print(s)

rn <- test.cmp (function () 
  { s <- 0; for (i in 1:1000000) s <- s + tl(rv,5); s })
sys.time(s <- rn())
print(s)

rn <- test.cmp (function () 
  { s <- 0; for (i in 1:1000000) s <- s + hd(tl(rv,5)); s })
sys.time(s <- rn())
print(s)


test.name <- "tst-subfns.replace"

rv0 <- seq(1,2,length=100001)

rn <- test.cmp (function (rv) { for (i in 1:5000) hd(rv) <- 9; rv })
sys.time(rv <- rn(rv0))
print(rv[1:6])

rn <- test.cmp (function (rv) { for (i in 1:5000) hd(rv,5) <- 9; rv })
sys.time(rv <- rn(rv0))
print(rv[1:6])

rn <- test.cmp (function (rv) { for (i in 1:5000) tl(rv) <- 9; rv })
sys.time(rv <- rn(rv0))
print(rv[99996:100001])

rn <- test.cmp (function (rv) { for (i in 1:5000) tl(rv,5) <- 9; rv })
sys.time(rv <- rn(rv0))
print(rv[99996:100001])

rn <- test.cmp (function (rv) { for (i in 1:5000) hd(tl(rv,5),2) <- 9; rv })
sys.time(rv <- rn(rv0))
print(rv[99996:100001])

cnt <- 0
f <- test.cmp (function (i) { cnt <<- cnt + i + 1i; i })
rn <- test.cmp (function (rv) {for (i in 1:5000) hd(tl(rv,f(5)),f(2)) <- 9; rv})
sys.time(rv <- rn(rv0))
print(rv[99996:100001])
print(cnt)
