source("time.r")
 
test.name <- "tst-vec-en-del.enlarge"

f0 <- test.cmp (function (n,v)
{ m <- length (v) 
  v1 <- v[[1]]
  for (i in 1:n) v[[m+i]] <- v1
  wait(v)
})

n <- 100000

v <- rep(list(1.2,4.9),10000)
sys.time(r <- f0(n,v))
print(c(length(r),sum(unlist(r))))

v <- rep(c("1.2","4.9"),10000)
sys.time(r <- f0(n,v))
print(c(length(r),sum(as.numeric(r))))

f1 <- test.cmp(function (n)
{
  v <- numeric(0)
  for (i in 1:n) v[i] <- i
  wait(v)
})

f2 <- test.cmp(function (n)
{
  v <- numeric(0)
  for (i in 1:n) { length(v) <- i; v[i] <- i; }
  wait(v)
})

f5 <- test.cmp(function (n)
{
  v <- list()
  for (i in 1:n) v[[i]] <- i
  wait(v)
})

f6 <- test.cmp(function (L)
{
  L[[1]] <- 2
  L$abc <- 3
  wait(L)
})

n <- 30000

sys.time(for (j in 1:4) r <- f1(n))
print(any(r!=1:n))

sys.time(for (j in 1:4) r <- f2(n))
print(any(r!=1:n))

sys.time(for (j in 1:4) r <- f5(n))
print(any(unlist(r)!=1:n))

n <- 1000000
L <- rep(list(1),n)
sys.time(for (j in 1:50) r <- f6(L))
print(c(length(r),r[[1]],r[[n]],r[[n+1]]))


test.name <- "tst-vec-en-del.with-c"

f3 <- test.cmp(function (n)
{
  v <- numeric(0)
  for (i in 1:n) v <- c(v,i)
  wait(v)
})

f7 <- test.cmp(function (x,n)
{
  v <- numeric(0)
  for (i in 1:n) v <- c(v,x)
  wait(v)
})

f4 <- test.cmp(function (n)
{
  v <- numeric(0)
  for (i in n:1) v <- c(i,v)
  wait(v)
})

n <- 100000

sys.time(for (j in 1:2) r <- f3(n))
print(any(r!=1:n))

n <- 50000

sys.time(for (j in 1:2) r <- f7(c(abc=1.1),n))
print(any(r!=1.1))
print(length(names(r)))
print(any(names(r)!="abc"))

n <- 40000

sys.time(for (j in 1:2) r <- f4(n))
print(any(r!=1:n))


test.name <- "tst-vec-en-del.delete"

f <- test.cmp (function (n,v)
{ for (i in 1:n) v[[100+i]] <- NULL
  v
})

n <- 5000000

v <- rep(list(1.2,4.9),10000)
sys.time(r <- f(n,v))
print(c(length(r),sum(unlist(r))))

f <- test.cmp (function (n,v)
{ for (i in 1:n) v[100+i] <- NULL
  v
})

n <- 40000

v <- rep(list(1.2,4.9),10000)
sys.time(r <- f(n,v))
print(c(length(r),sum(unlist(r))))

n <- 20000

v <- rep(list(1.2,4.9),10000)
names(v) <- rep("abc",10000)
sys.time(r <- f(n,v))
print(c(length(r),sum(unlist(r))))

f <- test.cmp (function (n,v)
{ for (i in 1:n) v[1000:1002] <- NULL
  v
})

n <- 700000

v <- rep(list(1.2,4.9),10000)
sys.time(r <- f(n,v))
print(c(length(r),sum(unlist(r))))

g1 <- test.cmp(function (n)
{
  v <- numeric(n)
  for (i in n:1) length(v) <- i-1
  wait(v)
})

g2 <- test.cmp(function (n)
{
  v <- rep(list(1),n)
  for (i in 1:n) v[[1]] <- NULL
  wait(v)
})

g3 <- test.cmp(function (n)
{
  v <- rep(list(1),n)
  for (i in n:1) v[[i]] <- NULL
  wait(v)
})

n <- 40000

sys.time(for (j in 1:4) r <- g1(n))
print(r)

sys.time(for (j in 1:4) r <- g2(n))
print(r)

sys.time(for (j in 1:4) r <- g3(n))
print(r)


# correctness checks.

a <- c("abc","def","ghi","xxx")
b <- a
a[[6]] <- "yyy"
print(c(a,b))

a <- list(a=3,b=T,c="aa",d=list(1),e=4L,f=3,g=90)
b <- a
b[["b"]] <- NULL
print(b)

b[2:3] <- NULL
print(b)

b[c(1,4)] <- NULL
print(b)
