source("time.r")
 

test.name <- "tst-which-match.which"

f <- test.cmp (function (w,n)
{ for (i in 1:n) r <- which(w)
  r
})

sys.time(r <- f(c(FALSE,FALSE,TRUE,FALSE,TRUE),2000000))
print(r)

sys.time(r <- f((1:10000)>9990,100000))
print(r)

test.name <- "tst-which-match.which.max"

f <- test.cmp (function (w,n)
{ for (i in 1:n) r <- which.max(w)
  r
})

sys.time(r <- f(c(NA,FALSE,TRUE,FALSE,FALSE,TRUE,FALSE),2000000))
print(r)

sys.time(r <- f((1:10000)>5000,100000))
print(r)

sys.time(r <- f(1:10000,100000))
print(r)

sys.time(r <- f(10000:1,100000))
print(r)

sys.time(r <- f((1:10000)+0.1,100000))
print(r)

sys.time(r <- f((10000:1)+0.1,100000))
print(r)
 

test.name <- "tst-which-match.match"

f <- test.cmp (function (a,b,n)
{ for (i in 1:n) r <- match(a,b)
  r
})

sys.time(r <- f(c("ab","cd"),c("00","xy","pp","ab","qq"),3000000))
print(r)

a <- rep(c("ab","cd"),50)
b <- c(paste0("a",1:1000),"xy","pp","ab","qq",paste0("b",1:1000))
sys.time(r <- f(a,b,100000))
print(r)

a <- 1:500
b <- c(933,431)
bi <- c(933L,431L)

sys.time(r <- f(a,rev(a),200000))
print(r)

sys.time(r <- f(a,bi,200000))
print(r)

sys.time(r <- f(bi,a,200000))
print(r)

sys.time(r <- f(33L,a,1000000))
print(r)

sys.time(r <- f(a,b,200000))
print(r)

sys.time(r <- f(b,a,200000))
print(r)

sys.time(r <- f(33,a,1000000))
print(r)
 

test.name <- "tst-which-match.%in%"

f <- test.cmp (function (a,b,n)
{ for (i in 1:n) r <- a %in% b
  r
})

sys.time(r <- f(c("ab","cd"),c("00","xy","pp","ab","qq"),3000000))
print(r)

a <- rep(c("ab","cd"),50)
b <- c(paste0("a",1:1000),"xy","pp","ab","qq",paste0("b",1:1000))
sys.time(r <- f(a,b,100000))
print(r)

a <- 1:500
bi <- c(933L,431L)

sys.time(r <- f(a,bi,200000))
print(r)

sys.time(r <- f(bi,a,200000))
print(r)

sys.time(r <- f(a,rev(a),200000))
print(r)

sys.time(r <- f(33L,a,1000000))
print(r)


test.name <- "tst-which-match.sets"

f <- test.cmp (function (x,y,n) { for (i in 1:n) r <- union(x,y); r })

sys.time(r <- f(10:15,20:25,200000))
print(r)

set.seed(1)

a <- sample(paste("a",1:1000,sep=""))
b <- sample(paste("a",900:2000,sep=""))

sys.time(r <- f(a,b,20000))
print(length(r))

f <- test.cmp (function (x,y,n) { for (i in 1:n) r <- intersect(x,y); r })

sys.time(r <- f(1:15,10:25,200000))
print(r)

set.seed(1)

a <- sample(paste("a",1:999,sep=""))
b <- sample(paste("a",900:2000,sep=""))

sys.time(r <- f(a,b,40000))
print(length(r))

f <- test.cmp (function (x,y,n) { for (i in 1:n) r <- setdiff(x,y); r })

sys.time(r <- f(1:15,10:25,200000))
print(r)

set.seed(1)

a <- sample(paste("a",1:999,sep=""))
b <- sample(paste("a",900:2000,sep=""))

sys.time(r <- f(a,b,20000))
print(length(r))

f <- test.cmp (function (x,y,n) { for (i in 1:n) r <- setequal(x,y); r })

sys.time(r <- f(c(2:25,1L),2:26,200000))
print(r)

set.seed(1)

a <- paste("a",1:999,sep="")
b <- sample(a)

sys.time(r <- f(a,b,20000))
print(r)


test.name <- "tst-which-match.duplicated"

set.seed(1)

n <- sample(1:10000,10000,replace=TRUE)
a <- paste("a",n,sep="")

f <- test.cmp (function (w,k) { for (i in 1:k) r <- duplicated(w); r })

sys.time(r <- f(n,10000))
print(r[9990:10000])

sys.time(r <- f(a,10000))
print(r[9990:10000])
